{# Templates/General/transferUnits.html.twig #}
{# Page to transfer units between the city and a general #}

{% extends 'base.html.twig' %}

{% block javascripts %}
    <script type="text/javascript">
        //<![CDATA[
        function enable(e,cond) {
            let v = cond ? 1. : 0.2;
            e.style.filter="progid:DXImageTransform.Microsoft.Alpha(opacity="+(v*100)+");";
            e.style.opacity = v;
        }

        function delta(label,n) {
            let c = document.getElementById("c"+label);
            let g = document.getElementById("g"+label);
            let i = document.getElementById("i"+label);
            let cv = parseInt(c.innerHTML) - n;
            let gv = parseInt(g.innerHTML) + n;
            if( cv < 0 ) {
                gv += cv;
                cv = 0;
            }
            if( gv < 0 ) {
                cv += gv;
                gv = 0;
            }
            i.value = cv;
            c.innerHTML = cv;
            g.innerHTML = gv;
            try {
                enable(c.parentNode,cv>0);
                enable(g.parentNode,gv>0);
                enable(document.getElementById("p"+label),cv>0);
                enable(document.getElementById("m"+label),gv>0);
                enable(document.getElementById("pp"+label),cv>=10);
                enable(document.getElementById("mm"+label),gv>=10);
            } catch( e ) {
                alert(e);
            }
        }
        //]]>
    </script>
{% endblock %}

{% set unitsInfo = {
    0 : { 'name': 'soldier',        'id':'sold' },
    1 : { 'name': 'archer',         'id':'arch' },
    2 : { 'name': 'horseman',       'id':'cav' },
    3 : { 'name': 'paladin',        'id':'pal' },
    4 : { 'name': 'pikeman',        'id':'piq' },
    5 : { 'name': 'knight',         'id':'chev' },
    6 : { 'name': 'mountedArcher',  'id':'caa' },
    7 : { 'name': 'ballista',       'id':'bal' },
    8 : { 'name': 'catapult',       'id':'cat' },
} %}

{# Is that Defense or Garrison? #}
{% set nodeArmyContainer = general.owner == general.location.owner ? general.owner.city.defense : general.location.armyContainer %}

{% block content %}
    <div class="mxcontent" id="mxcontent">
        <form method="POST" action="{{ path('app_general_confirmunitstransfer', {'generalId':general.id}) }}">
            {# <input type="hidden" name="units" value="null"> Is that even usefull? #}
            <div class="table2th_top">
                <h1>Général {{ general.name }}</h1>
                <div class="table2th_bottom">
                    <div class="table2th_bg">
                        <table class="units">
                            <tbody><tr>
                                <th>
                                    {{ general.location.name }}
                                </th>
                                {% for key, unitInfo in unitsInfo %}
                                    {% set unitName = unitInfo['name'] %}
                                    {% set localCount = nodeArmyContainer.unitCount(unitName) %}
                                    <td>
                                        <div
                                                {% if localCount == 0 %}
                                                    class="unit disable" style="opacity: 0.2;"
                                                {% else %}
                                                    class="unit" style="opacity: 1.0;"
                                                {% endif %}
                                                     onmouseover="showHint(this,
                                                             '{{ ('units.'~unitName~'.name') | trans([], "Common") }}',
                                                             '{{ ('units.'~unitName~'.desc') | trans([], "Common") }}')"
                                                     onmouseout="hideHint()">
                                            <img src="{{ asset('img/icons/u_' ~ unitName ~ '.png') }}" alt="">
                                            <span class="n" id="c{{ unitInfo['id'] }}">
                                                {{ localCount }}
                                            </span>
                                        </div>
                                    </td>
                                {% endfor %}
                            </tr>
                            <tr>
                                <th>
                                    {{ general.name }}
                                </th>
                                {% for key, unitInfo in unitsInfo %}
                                    {% set unitName = unitInfo['name'] %}
                                    {% set unitCount = general.armyContainer.unitCount(unitName) %}
                                    <td>
                                        <div
                                                {% if unitCount == 0 %}
                                                    class="unit disable" style="opacity: 0.2;"
                                                {% else %}
                                                    class="unit" style="opacity: 1.0;"
                                                {% endif %}
                                                onmouseover="showHint(this,
                                                        '{{ ('units.'~unitName~'.name') | trans([], "Common") }}',
                                                        '{{ ('units.'~unitName~'.desc') | trans([], "Common") }}')"
                                                onmouseout="hideHint()">
                                            <img src="{{ asset('img/icons/u_' ~ unitName ~ '.png') }}" alt="">
                                            <span class="n" id="g{{ unitInfo['id'] }}">
                                                {{ unitCount }}
                                            </span>
                                        </div>
                                    </td>
                                {% endfor %}
                            </tr>
                            <tr>
                                <th>Actions</th>
                                {% for key, unitInfo in unitsInfo %}
                                    {% set unitId = unitInfo['id'] %}
                                    {% set unitName = unitInfo['name'] %}
                                    {% set generalCount = general.armyContainer.unitCount(unitName) %}
                                    {% set localCount = nodeArmyContainer.unitCount(unitName) %}

                                    {% set plusOneOpacity = localCount > 0 ? '1.0' : 0.2 %}
                                    {% set plusTenOpacity = localCount > 9 ? '1.0' : 0.2 %}
                                    {% set minusOneOpacity = generalCount > 0 ? '1.0' : 0.2 %}
                                    {% set minusTenOpacity = generalCount > 9 ? '1.0' : 0.2 %}

                                    <td>
                                        <input type="hidden" name="{{ unitName }}" value="0" id="i{{ unitId }}">
                                        <ul class="moreminus">
                                            <li>
                                                <a href="#" id="p{{ unitId }}" class="plusone" onclick="return delta('{{ unitId }}',1)" style="opacity: {{ plusOneOpacity }};"></a>
                                            </li>
                                            <li>
                                                <a href="#" id="m{{ unitId }}" class="minusone" onclick="return delta('{{ unitId }}',-1)" style="opacity: {{ plusTenOpacity }};"></a>
                                            </li>
                                            <li>
                                                <a href="#" id="pp{{ unitId }}" class="plusten" onclick="return delta('{{ unitId }}',10)" style="opacity: {{ minusOneOpacity }};"></a>
                                            </li>
                                            <li>
                                                <a href="#" id="mm{{ unitId }}" class="minusten" onclick="return delta('{{ unitId }}',-10)" style="opacity: {{ minusTenOpacity }};"></a>
                                            </li>
                                        </ul>
                                    </td>
                                {% endfor %}
                            </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
            <ul class="punits">
                <li>
                    <input type="submit" value="OK" class="button">
                </li>
                <li><a href="{{ path('app_map_focusGeneral', {'worldId':general.location.owningWorld.id, 'generalId': general.id}) }}" class="button">Annuler</a></li>
            </ul>
        </form>

        <script type="text/javascript">
            delta('sold',0);
            delta('arch',0);
            delta('cav',0);
            delta('pal',0);
            delta('piq',0);
            delta('chev',0);
            delta('caa',0);
            delta('bal',0);
            delta('cat',0);
        </script>
    </div>
{% endblock %}